package com.example2.administrator.myapplication2;

import android.app.Activity;
import android.os.Build;
import android.os.Bundle;
import android.view.View;
import android.view.WindowManager;
import android.widget.Button;
import android.annotation.SuppressLint;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Calendar;
import java.util.UUID;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.util.Log;
import android.view.Gravity;
import android.view.MotionEvent;
import android.widget.Toast;
import android.widget.EditText;



@SuppressLint("ClickableViewAccessibility") public class MainActivity extends Activity {
    private static final String TAG = "THINBTCLIENT";

    private static final boolean D = true;

    private BluetoothAdapter mBluetoothAdapter = null;

    private BluetoothSocket btSocket = null;

    private OutputStream outStream = null;
    private Button btn=null;
    private Button btn2=null;
    private EditText et=null;
    private static final UUID MY_UUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");


    private static String address = "30:14:08:18:00:84"; // <==要连接的蓝牙设备MAC地址


    @Override

    public void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.KITKAT) {
            getWindow().addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS);
            getWindow().addFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_NAVIGATION);
        }
        et=(EditText)super.findViewById(R.id.yzm);
        btn2=(Button)super.findViewById(R.id.button2);
        btn2.setOnClickListener(new imageButtonOnClickListener());




        btn=(Button)super.findViewById(R.id.button);




        if (D)
            Log.e(TAG, "+++ ON CREATE +++");
        mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();

        if (mBluetoothAdapter == null) {
            Toast.makeText(this, "蓝牙设备不可用，请打开蓝牙！", Toast.LENGTH_LONG).show();
            finish();
            return;
        }


        if (!mBluetoothAdapter.isEnabled()) {
            Toast.makeText(this,  "请打开蓝牙并重新运行程序！", Toast.LENGTH_LONG).show();
            finish();
            return;

        }


        if (D)
            Log.e(TAG, "+++ DONE IN ON CREATE, GOT LOCAL BT ADAPTER +++");

    }






    private class imageButtonOnClickListener implements View.OnClickListener{
        public void onClick(View view){

            String str1="";

            str1=et.getText().toString();
            Calendar cal = Calendar.getInstance();
            int year = cal.get(Calendar.YEAR);
            int month = cal.get(Calendar.MONTH);
            int day = cal.get(Calendar.DATE);
            int hour = cal.get(Calendar.HOUR_OF_DAY);
            int minute = cal.get(Calendar.MINUTE);


            int ahour=hour+1;
            int s0=year*3+(10*month+9*day+8*hour)*(hour+1)+2561;
            String s1=Integer.toOctalString(s0);
            int s2=Integer.parseInt(s1);
            String s3=Integer.toHexString(s2);

            if(s3.equals(str1)) {
                Toast toast=Toast.makeText(getApplicationContext(),"现在可以开锁了，"+ahour+"点前有效",Toast.LENGTH_SHORT);
                toast.show();

                btn.setOnTouchListener(new Button.OnTouchListener() {

                    @Override
                    public boolean onTouch(View v, MotionEvent event) {

                        String message;
                        byte[] msgBuffer;
                        int action = event.getAction();
                        switch (action) {
                            case MotionEvent.ACTION_UP:
                                btn.setBackgroundResource(R.drawable.unlocked);
                                try {
                                    outStream = btSocket.getOutputStream();

                                } catch (IOException e) {
                                    Log.e(TAG, "ON RESUME: Output stream creation failed.", e);
                                }

                                Calendar cal = Calendar.getInstance();
                                int year = cal.get(Calendar.YEAR);
                                int month = cal.get(Calendar.MONTH)+1;
                                int day = cal.get(Calendar.DATE);
                                int hour = cal.get(Calendar.HOUR_OF_DAY);
                                int minute = cal.get(Calendar.MINUTE);


                                int min=minute/30;
                                int s0=(year+2*month+3*day+4*hour+5*min)*(min+1)*(min+1)+70000;

                               message=Integer.toHexString(s0);


                                msgBuffer = message.getBytes();

                                try {
                                    outStream.write(msgBuffer);

                                } catch (IOException e) {
                                    Log.e(TAG, "ON RESUME: Exception during write.", e);
                                }
                                break;
                        }
                        return false;
                    }


                });

            }

            else
            {
                Toast toast=Toast.makeText(getApplicationContext(),"验证码错误",Toast.LENGTH_SHORT);

                toast.show();
            }

        }

    }



    @Override

    public void onStart() {

        super.onStart();

        if (D) Log.e(TAG, "++ ON START ++");
    }


    @Override

    public void onResume() {

        super.onResume();
        if (D) {
            Log.e(TAG, "+ ON RESUME +");
            Log.e(TAG, "+ ABOUT TO ATTEMPT CLIENT CONNECT +");

        }
        DisplayToast("正在尝试连接智能锁，请稍后····");
        BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);

        try {

            btSocket = device.createRfcommSocketToServiceRecord(MY_UUID);

        } catch (IOException e) {

            DisplayToast("套接字创建失败！");
        }

        mBluetoothAdapter.cancelDiscovery();
        try {

            btSocket.connect();
            DisplayToast("连接成功建立，数据连接打开！");


        } catch (IOException e) {

            try {
                btSocket.close();
                DisplayToast("失败");
            } catch (IOException e2) {


                DisplayToast("连接没有建立，无法关闭套接字！");
            }

        }


        // Create a data stream so we can talk to server.

        if (D)
            Log.e(TAG, "+ ABOUT TO SAY SOMETHING TO SERVER +");


    }


    @Override

    public void onPause() {

        super.onPause();


        if (D)
            Log.e(TAG, "- ON PAUSE -");
        if (outStream != null) {
            try {
                outStream.flush();
            } catch (IOException e) {
                Log.e(TAG, "ON PAUSE: Couldn't flush output stream.", e);
            }

        }


        try {
            btSocket.close();
        } catch (IOException e2) {

            DisplayToast("套接字关闭失败！");
        }

    }


    @Override

    public void onStop() {

        super.onStop();

        if (D)Log.e(TAG, "-- ON STOP --");

    }


    @Override

    public void onDestroy() {

        super.onDestroy();

        if (D) Log.e(TAG, "--- ON DESTROY ---");

    }
    public void DisplayToast(String str)
    {
        Toast toast=Toast.makeText(this, str, Toast.LENGTH_SHORT);
        toast.setGravity(Gravity.TOP, 0, 220);
        toast.show();

    }

}
